# showing sourced to lower memory footprint
  global db
  global selectiontypes
  global presentationbehtypes
  global states
  global showtypes
  global tvratingnums tvratingvals
  global showingbitnums showingbitvals
  global advisorynums advisoryvals
  global mpaaratingnums mpaaratingvals
  global premieretypes
  global images
  global cache_sp_fsid cache_sp_key

  foreach {v g} {showtype "Show Types" bits "All Day Ticket" av "Audio & Video"} {
    foreach {i start end} [expr {$::dtivo ? {-1 -1 -1} : [getGenreIndex $g 1]}] break
    set ${v}index $i
    set ${v}indexend $end
  }

  if {[string index $objectid 0] == "/"} {
    set objectid [string range $objectid 1 end]
  }
  puts $chan [html_start "Showing"]
  RetryTransaction {
    if { [regexp {([0-9]*)/(.*)} $objectid junk fsid subobjid] } {
      set showing [db $db openidconstruction $fsid $subobjid]
    } else {
      set showing [db $db openid $objectid]
    }
    set rec [dbobj $showing get IndexUsedBy]
    set day [dbobj $showing get Date]
    set time [dbobj $showing get Time]
    set timestr [format "%05d" $time]
    set recfsid ""
    if { $rec == "" } {
      set recfsid [lindex [get_fsidbyprefix "/Recording/Active" "4:$day:$timestr:"] 0]
    }
  }
  #  set recfsid ""
  #  if { $rec == "" } {
  #    ForeachMfsFile fsid name type "/Recording/Active" "4:$day:$timestr:" {
  #      set recfsid $fsid
  #    }
  #  }
  update_sp_cache

  RetryTransaction {
    if { [regexp {([0-9]*)/(.*)} $objectid junk fsid subobjid] } {
      set showing [db $db openidconstruction $fsid $subobjid]
    } else {
      set showing [db $db openid $objectid]
    }
    set rec [dbobj $showing get IndexUsedBy]
    set station [dbobj $showing get Station]
    set stationid [dbobj $station fsid]
    if { $rec == "" && $recfsid != "" } {
      set rec [db $db openid $recfsid]
      set showing2 [dbobj $rec get Showing]
      set station2 [dbobj $showing2 get Station]
      set stationfsid2 [dbobj $station2 fsid]
      if { $stationid != $stationfsid2 } {
        set rec ""
      } else {
        set showing $showing2
      }
    }
    if { $rec != "" && $recfsid == "" } {
      set recfsid [dbobj $rec fsid]
    }
    #---------------------------------------------------------------------------------------
    #Get general data here, rather than over and over again below
    #---------------------------------------------------------------------------------------
    set program [dbobj $showing get Program]
    set title [strim [dbobj $program get Title]]
    set titlePlain $title
    set series [dbobj $program get Series]
    set description [strim [dbobj $program get Description]]
    set movieyear [dbobj $program get MovieYear]
    if { [getStationData chinfo $stationid 0] } {
      set channum $chinfo(stanum)
      set callsign $chinfo(sign)
    } else {
      set callsign [dbobj $station get CallSign]
    }

    #titlestrg is needed for the internet database searchs (IMDB and TvTome)
    set titlestrg [httpMapReply [strim [dbobj $program get Title]]]
    regsub -all "\%26" $titlestrg "and" titlestrg

    set starrating [dbobj $program get StarRating]
    if { $starrating > 0 } {
      set starratingstr ""
      for {set i 0} {$i < [expr ($starrating + 1) / 2]} {incr i} {
        append starratingstr "*"
      }
      if { [expr ($starrating + 1) % 2] == 1 } {
        append starratingstr "&frac12;"
      }
    }
    set seriesfsid ""
    set thumbs ""
    if { $series != "" } {
      set seriesfsid [dbobj $series fsid]
      set thumbs "[html_link "/thumbs/$seriesfsid" "<font size=1>(No thumbs)</font>"] "
      set score [dbobj $series get ThumbData]
      if { $score != "" } {
        set imagenum [get_thumbimage $score 1]
        if { [lindex $imagenum 0] >= 0} {
          set imagef [lindex $images [lindex $imagenum 0]]
          set thconf [lindex $imagenum 1]
          if { $thconf > 0 } {
            set thumbs [html_link "/thumbs/$seriesfsid" [img $imagef "Confidence: $thconf"]]
          }
        }
      }
    }
    if { $seriesfsid != "" } {
      set title [html_link "/series/$seriesfsid" $title]
    }
    if { $rec != "" } {
      set seltype [dbobj $rec get SelectionType]
      if {$::version >= 3} {
        set recbeh [dbobj $rec get RecordingBehavior]
        set presbeh [dbobj $recbeh get PresentationBehavior]
        set progbeh [dbobj $recbeh get ProgramGuideBehavior]
        if { $presbeh == 10 || $presbeh == 9 || $progbeh == 3 || $progbeh == 8 } {
          if { $title == "" } {
            set title "Manual Recording"
          } else {
            set title "Manual: $title"
          }
        }
      } else {
        if { $seltype == 10 || $seltype == 5 } {
          if { $title == "" } {
            set title "Manual Recording"
          } else {
            set title "Manual: $title"
          }
        }
      }
    }
    puts $chan [bodytext_start]
    puts $chan [h1 "$thumbs$title"]
    puts $chan [bodytext_end]
    puts $chan [html_table_start "width=90%" "" ""]

    set eptitleraw [dbobj $program get EpisodeTitle]
    if {$series != ""} {
      set episodic [defaultval 1 [dbobj $series get Episodic]]
    } elseif { $eptitleraw != "" } {
      set episodic 1
    } else {
      set episodic 0
    }

    set tmstype 1
    set tmsid [dbobj $program get TmsId]
    if { [string range $tmsid 0 1] == "MV" } {
      set tmstype 0
    }
    if { [string length $tmsid] == 0 } {
      set tmstype $episodic
    }

    scan $callsign "MC%d" temp
    if { ![info exists temp] } {
      # don't display for music channels
      if { $tmstype == 1 } {
        #TV SHOWS
        set partindex [dbobj $showing get PartIndex]
        set partcount [dbobj $showing get PartCount]
        set partstr ""
        if { $partcount != "" && $partindex != "" } {
          set partstr " ($partindex/$partcount)"
        }
        if { $episodic == 1 } {
          puts $chan [tr "" [td "Episode&nbsp;Title"] [td [strim [dbobj $program get EpisodeTitle]]$partstr]]
          puts $chan [tr "" [td "Episode&nbsp;Description"] [td [strim [dbobj $program get Description]]]]
          puts $chan [tr "" [td "Episode Number"] [td [expand_epnum [dbobj $program get EpisodeNum] [dbobj $program get Description]]]]
          puts $chan [tr "" [td "More Info"] [td "[html_link "http://www.tv.com/search.php?type=11&stype=all&qs=$titlestrg&x=0&y=0" "Search TV.com for '$titlePlain'" "" "target=_new"] --- Search provided by [html_link "http://www.tv.com" "TV.com" "" "target=_new"]."]]

          set altepisodenum [dbobj $program get AltEpisodeNum]
          if { $altepisodenum != "" } {
            puts $chan [tr "" [td "Alt Episode&nbsp;Number"] [td $altepisodenum]]
          }
        }  else {
          puts $chan [tr "" [td "Description"] [td [strim [dbobj $program get Description]]]]
        }
      } else {
        # MOVIES
        puts $chan [tr "" [td "Description"] [td [strim [dbobj $program get Description]]]]
        puts $chan [tr "" [td "Year"] [td [dbobj $program get MovieYear]]]
        if { $movieyear == "" } {
          puts $chan "<tr><td>More Info</td><td>[html_link "http://www.imdb.com/Tsearch?title=$titlestrg&type=substring&sort=smart&tv=both" "Search IMDb for '$titlePlain'" "" "target=_new"]"
        } else {
          puts $chan "<tr><td>More Info</td><td>[html_link "http://www.imdb.com/Tsearch?title=$titlestrg&type=substring&from_year=$movieyear&to_year=$movieyear&sort=smart&tv=both" "Search IMDb  for '$titlePlain'" "" "target=_new"]"
        }
        puts $chan " --- Search provided by [html_link "http://www.imdb.com" "The Internet Movie Database" "" "target=_new"].</td></tr>"
        if { $starrating > 0 } {
            puts $chan "<TR><TD>Rating</TD><TD>$starratingstr</TD></TR>"
        }
      }
    }

    set durationsecs 0
    set endpadding ""
    set startpadding ""
    if { $rec != "" } {
      set stopdate [dbobj $rec get StopDate]
      set stoptime [dbobj $rec get StopTime]
      if { $stoptime == "" } {
        set stoptime [expr ([dbobj $showing get Time] + [dbobj $showing get Duration]) % 86400]
      }
      set startdate [dbobj $rec get StartDate]
      set starttime [dbobj $rec get StartTime]
      if { $starttime == "" } {
        set starttime [dbobj $showing get Time]
      }
      if { $stopdate != "" } {
        set durationsecs [expr ($stopdate * 86400 + $stoptime) - ($startdate * 86400 + $starttime)]
      }
      set startpadding [dbobj $rec get StartPadding]
      set endpadding [dbobj $rec get EndPadding]
    }
    set showingdurationsecs [dbobj $showing get Duration]
    if { $durationsecs == 0 } {
      set durationsecs $showingdurationsecs
    }
    set duration [format "%d:%02d" [expr $durationsecs / (60*60)] [expr ($durationsecs % (60*60)) / 60]]
    if { [expr $durationsecs - $showingdurationsecs + 90] < 0 } {
      append duration [format "/%d:%02d" [expr $showingdurationsecs / (60*60)] [expr ($showingdurationsecs % (60*60)) / 60]]
    }
    if { $tmstype != 1 } {
      set movieruntime [dbobj $program get MovieRunTime]
      if { $movieruntime > 0 } {
        if { $::dtivo } {
          append duration [format " (%d:%02d)" [expr $movieruntime / 60] [expr ($movieruntime % 60)]]
        } else {
          append duration [format " (%d:%02d)" [expr $movieruntime / 100] [expr ($movieruntime % 100)]]
        }
      }
    }
    puts $chan [tr "" [td "Duration"] [td $duration]]

    if {$startpadding != ""} {
      puts $chan [tr "" [td "Start Padding"] [td ${startpadding}s]]
    }
    if {$endpadding != ""} {
      puts $chan [tr "" [td "End Padding"] [td ${endpadding}s]]
    }
    
    set originalairdate [dbobj $program get OriginalAirDate]
    if { $originalairdate != "" } {
      set originalairdatesecs [expr $originalairdate * 86400]
      if {$::lang == "en"} {
        set daystr [nth_sup [clock format $originalairdatesecs -format "%e"]]
        set airdatestr [clock format $originalairdatesecs -format "$daystr %b %Y"]
      } else {
        set airdatestr [clock format $originalairdatesecs -format "%1m/%1d/%Y"]
      }
      puts $chan [tr "" [td "Original Air Date"] [td $airdatestr]]
    }

    set premiere [dbobj $showing get Premiere]
    if { $premiere != "" } {
      puts $chan [tr "" [td "Premiere Type"] [td [lindex $premieretypes [expr $premiere - 1]]]]
    }

    set actors [dbobj $program get Actor]
    if { $actors != "" } {
      set actorstr [PrintNames $actors 1]
      puts $chan [tr "" [td "Actors"] [td $actorstr]]
    }

    set gueststars [dbobj $program get GuestStar]
    if { $gueststars != "" } {
      set gueststarstr [PrintNames $gueststars 1]
      puts $chan [tr "" [td "Guest Stars"] [td $gueststarstr]]
    }

    set hosts [dbobj $program get Host]
    if { $hosts != "" } {
      set hoststr [PrintNames $hosts 1]
      puts $chan [tr "" [td "Hosts"] [td $hoststr]]
    }

    set directors [dbobj $program get Director]
    if { $directors != "" } {
      set directorstr [PrintNames $directors 2]
      puts $chan [tr "" [td "Directors"] [td $directorstr]]
    }

    set execproducers [dbobj $program get ExecProducer]
    if { $execproducers != "" } {
      set execproducerstr [PrintNames $execproducers]
      puts $chan [tr "" [td "Exec Producers"] [td $execproducerstr]]
    }

    set producers [dbobj $program get Producer]
    if { $producers != "" } {
      set producerstr [PrintNames $producers]
      puts $chan [tr "" [td "Producers"] [td $producerstr]]
    }

    set writers [dbobj $program get Writer]
    if { $writers != "" } {
      set writerstr [PrintNames $writers]
      puts $chan [tr "" [td "Writers"] [td $writerstr]]
    }

    set genres [dbobj $program get Genre]
    if { $::dtivo } {
      if { $genres != "" } {
        set genrestr ""
        set showingbitstr ""
        set showingtypestr ""
        set advisorystr ""
        foreach genre $genres {
          set genreindex [getGenreIndex $genre]
          if { $genreindex != -1 } {
            if {$genre >= 30 && $genre <= 45} {
              if { $advisorystr != "" } {
                append advisorystr ", "
              }
              append advisorystr [strim [lindex $::genrevals $genreindex]]
            } elseif {($genreindex > $avindex && $genreindex <= $avindexend) || ($genreindex >= $bitsindex && $genreindex <= $bitsindexend)} {
              if { $showingbitstr != "" } {
                append showingbitstr ", "
              }
              append showingbitstr [strim [lindex $::genrevals $genreindex]]
            } elseif {$genreindex > $showtypeindex && $genreindex <= $showtypeindexend} {
              if { $showingtypestr != "" } {
                append showingtypestr ", "
              }
              append showingtypestr [strim [lindex $::genrevals $genreindex]]
            } else {
              if { $genrestr != "" } {
                append genrestr ", "
              }
              append genrestr [strim [lindex $::genrevals $genreindex]]
            }
          }
        }
        if { $genrestr != "" } {
          puts $chan [tr "" [td "Genres"] [td $genrestr]]
        }
      }
    } else {
      if { $genres != "" } {
        set genrestr ""
        foreach genre $genres {
          set genreindex [getGenreIndex $genre]
          if { $genreindex != -1 } {
            if { $genrestr != "" } {
              append genrestr ", "
            }
            append genrestr [strim [lindex $::genrevals $genreindex]]
          }
        }
        puts $chan [tr "" [td "Genres"] [td $genrestr]]
      }
    }

    if { $tmstype == 1 } {
      set tvrating [dbobj $showing get TvRating]
      if { $tvrating == "" } {
        # 6.3a has TvRating's in the Program
        catch {set tvrating [dbobj $program get TvRating]}
      }
      if { $tvrating != "" } {
        set tvratingindex [lsearch $tvratingnums $tvrating]
        if { $tvratingindex != -1 } {
          set tvratingstr [strim [lindex $tvratingvals $tvratingindex]]
        } else {
          set tvratingstr ""
        }
        puts $chan [tr "" [td "Rating"] [td $tvratingstr]]
      }
    } else {
      set mpaarating [dbobj $program get MpaaRating]
      if { $mpaarating != "" } {
        set mpaaratingindex [lsearch $mpaaratingnums $mpaarating]
        if { $mpaaratingindex != -1 } {
          set mpaaratingstr [strim [lindex $mpaaratingvals $mpaaratingindex]]
        } else {
          set mpaaratingstr ""
        }
        puts $chan [tr "" [td "Rating"] [td $mpaaratingstr]]
      }
    }

    if { $::dtivo } {
      if { $genres != "" } {
        if { $showingbitstr != "" } {
          puts $chan [tr "" [td "Bits"] [td $showingbitstr]]
        }
        if { $advisorystr != "" } {
          puts $chan [tr "" [td "Advisory"] [td $advisorystr]]
        }
        if { $showingtypestr != "" } {
          puts $chan [tr "" [td "Type"] [td $showingtypestr]]
        }
      }
    } else {
      set showingbits [dbobj $showing get Bits]
      if { $showingbits != "" } {
        set showingbitstr ""
        set index 0
        foreach showingbitnum $showingbitnums {
          if { $showingbitnum & $showingbits } {
            if { $showingbitstr != "" } {
              append showingbitstr ", "
            }
            append showingbitstr [strim [lindex $showingbitvals $index]]
          }
          incr index
        }
        puts $chan [tr "" [td "Bits"] [td $showingbitstr]]
      }

      set advisorys [dbobj $program get Advisory]
      if { $advisorys != "" } {
        set advisorystr ""
        foreach advisory $advisorys {
          set advisoryindex [lsearch $advisorynums $advisory]
          if { $advisoryindex != -1 } {
            if { $advisorystr != "" } {
              append advisorystr ", "
            }
            append advisorystr [strim [lindex $advisoryvals $advisoryindex]]
          }
        }
        puts $chan [tr "" [td "Advisory"] [td $advisorystr]]
      }

      set showtype [dbobj $program get ShowType]
      if { $showtype != "" } {
        set showstr [lindex $showtypes [expr $showtype - 1]]
        puts $chan [tr "" [td "Type"] [td $showstr]]
      }
    }

    if { $station != "" } {
      if { [info exists channum] } {
        puts $chan [tr "" [td "Channel"] [td [html_link "/channel/$stationid" "$channum $callsign"]]]
      } else {
        puts $chan [tr "" [td "Channel"] [td $callsign]]
      }
    }

    set showingstart [expr [dbobj $showing get Date] * 86400 + [dbobj $showing get Time]]
    if {$::lang == "en"} {
      set daystr [nth_sup [ftime $showingstart "%e"]]
      set timestr [ftime $showingstart "%a $daystr %b %H:%M"]
    } else {
      set timestr [ftime $showingstart "%1m/%1d %l:%M %P"]
    }
    puts $chan [tr "" [td "Showing Date"] [td $timestr]]

    if { $rec != "" } {
      set programsource [dbobj $rec get ProgramSource]
      set programsourcefsid ""
      if { $programsource != "" } {
        set programsource [lindex $programsource 0]
        set programsourcefsid [dbobj $programsource fsid]
        set programsourcetype [dbobj $programsource get Type]
      }
      set expirationdate [dbobj $rec get ExpirationDate]
      if { $expirationdate == 0 || $expirationdate == "" || $expirationdate == 24855 } {
        set timestr ""
      } else {
        set expirationsecs [expr $expirationdate * 86400 + [dbobj $rec get ExpirationTime]]
        if {$::lang == "en"} {
          set daystr [nth_sup [ftime $expirationsecs "%e"]]
          set timestr [ftime $expirationsecs "%a $daystr %b %H:%M"]
        } else {
          set timestr [ftime $expirationsecs "%1m/%1d %l:%M %P"]
        }
      }
      puts $chan [tr "" [td "Expiration Date"] [td $timestr]]

      set deletiondate [dbobj $rec get DeletionDate]
      if { $deletiondate == 0 || $deletiondate == "" || $deletiondate == 24855 } {
        set timestr ""
      } else {

        ## check for blank DeletionTime, per Cheezmo -- added by SteveT
        #set deletionsecs [expr $deletiondate * 86400 + [dbobj $rec get DeletionTime]]
        set deletiontime [dbobj $rec get DeletionTime]
        if { $deletiontime == "" } { set deletiontime 0 }
        set deletionsecs [expr $deletiondate * 86400 + $deletiontime]

        if {$::lang == "en"} {
          set daystr [nth_sup [ftime $deletionsecs "%e"]]
          set timestr [ftime $deletionsecs "%a $daystr %b %H:%M"]
        } else {
          set timestr [ftime $deletionsecs "%1m/%1d %l:%M %P"]
        }
      }
      puts $chan [tr "" [td "Deletion Date"] [td $timestr]]

      set canceldate [dbobj $rec get CancelDate]
      if { $canceldate == 0 || $canceldate == "" } {
        set timestr ""
      } else {
        set cancelsecs [expr $canceldate * 86400 + [dbobj $rec get CancelTime]]
        if {$::lang == "en"} {
          set daystr [nth_sup [ftime $cancelsecs "%e"]]
          set timestr [ftime $cancelsecs "%a $daystr %b %H:%M"]
        } else {
          set timestr [ftime $cancelsecs "%1m/%1d %l:%M %P"]
        }
      }
      puts $chan [tr "" [td "Cancel Date"] [td $timestr]]

      set cancelreason [dbobj $rec get CancelReason]
      if { $cancelreason == "" } {
        set cancelstr ""
      } else {
        set cancelstr [UIGetCancelReason [expr $cancelreason - 1]]
      }
      puts $chan [tr "" [td "Cancel Reason"] [td $cancelstr]]

      set errorstring [strim [dbobj $rec get ErrorString]]
      if { $errorstring != "" } {
        while { [set findex [string first "" $errorstring]] >= 0 } {
          set errorstring "[string range $errorstring 0 [expr $findex-1]]<BR>[string range $errorstring [expr $findex+1] end]"
        }
        puts $chan [tr "" [td "Error String"] [td $errorstring]]
      }

      set recquality [dbobj $rec get RecordQuality]
      switch -exact $recquality {
        0  { set recqualitystr "Basic" }
        40   { set recqualitystr "Medium" }
        75   { set recqualitystr "High" }
        default  { set recqualitystr "Best" }
      }
      puts $chan [tr "" [td "Quality"] [td $recqualitystr]]

      set score ""
      if {$::version >= 3} {
        if {$presbeh == 6} {
          set score [dbobj $rec get SubPriority]
        }
      } elseif {$seltype == 6} {
        set score [dbobj $rec get Score]
      }
      if {$score != ""} {
        set dscore [ReadableThumbs $score]
        puts $chan [tr "" [td "Score"] [td $dscore]]
      }

      set bookmark [dbobj $rec get Bookmark]
      if { $bookmark != "" } {
        set timems [expr [dbobj $bookmark get TimeMs] / 1000]
        set timestr [format "%d:%02d:%02d" [expr $timems / (60*60)] [expr ($timems % (60*60)) / 60] [expr $timems % 60]]
        puts $chan [tr "" [td "Bookmark"] [td $timestr]]
      }

      set nsecswatched [dbobj $rec get NSecondsWatched]
      if { $nsecswatched > 0 } {
        set timestr [format "%d:%02d:%02d" [expr $nsecswatched / (60*60)] [expr ($nsecswatched % (60*60)) / 60] [expr $nsecswatched % 60]]
        puts $chan [tr "" [td "Time Watched"] [td $timestr]]
      }

      set nvisits [dbobj $rec get NVisit]
      if { $nvisits > 0 } {
        puts $chan [tr "" [td "Num Visits"] [td $nvisits]]
      }

      if { $seltype != "" } {
        if {$::version >= 3} {
          if {$progbeh == 3} {
            if {$presbeh == 1} {
              set seltypestr "Manual"
            } elseif {$presbeh == 2} {
              set seltypestr "Manual Season Pass"
            } else {
              set seltypestr "Manual"
            }
          } else {
            set seltypestr [lindex $presentationbehtypes [expr $presbeh - 1]]
          }
        } else {
          set seltypestr [lindex $selectiontypes [expr $seltype - 1]]
        }
        puts $chan [tr "" [td "Selection Type"] [td $seltypestr]]
      }

      set state [dbobj $rec get State]
      set statestr [lindex $states [expr $state - 1]]
      puts $chan [tr "" [td "State"] [td $statestr]]

      if { [catch {dbobj $rec get StreamFileSize} streamsize] } {
        set streamsize 0
      }
      if { $streamsize == "" } {
        set streamsize 0
      }
      set parts [dbobj $rec get Part]
      if { ($streamsize == 0) && ($state == 3 || $parts == "") } {
        switch -exact $recquality {
          0  { set bitrate [expr $::uktivo ? 1700000 : 1630000] }
          40   { set bitrate 2760000 }
          75   { set bitrate 3660000 }
          default  { set bitrate 5960000 }
        }
        set seconds [dbobj $showing get Duration]
        set size "[expr ($seconds * ($bitrate / (8 * 1024))) / 1024] MB (estimated)"
      } else {
        set size 0
        if { $streamsize == 0 } {
          foreach part $parts {
            set file [dbobj $part get File]
            if { [catch {mfs streamsize $file} sizes] } {
            } else {
              incr size [expr ([lindex $sizes 0] / 1024) * [lindex $sizes 1] / 1024]
            }
          }
        } else {
          set size [expr $streamsize / 1024]
        }
        append size " MB"
      }
      puts $chan [tr "" [td "Size"] [td $size]]
      
      if {$state == 3 || $state == 4} {
        regsub -all {\?} $titlePlain {_} titlePlain
        regsub -all {\?} $eptitleraw {_} eptitleraw
        set r_name "\{$titlePlain\}\{[strim $eptitleraw]\}\{$callsign\}\{$recfsid\}"
        set    tdextract "[html_link tivo://$::ip_address/$recfsid view] "
        append tdextract "[html_link [html_encode /$r_name.tmf] tmf] "
        append tdextract "[html_link [html_encode /$r_name.ty] ty] "
        append tdextract "[html_link [html_encode /$r_name.asx] asx] "
#        if {$::conf(embed_player)} { 
#          regsub -all {'}  $titlePlain {} titlePlain
#          append tdextract [html_link "javascript:playstream('$recfsid', '[html_encode $titlePlain]')" "play" "play in embedded player"]
#        }
        puts $chan [tr "" [td "Extract links"] [td $tdextract]]
      } 
      
    }

    # added MFS Data and links for debugging -- SteveT
    if {$seriesfsid != ""} {
       set strSeries ", [html_link /object/$seriesfsid SeriesObject]"
    } else {
       set strSeries ""
    }
    set strMFSData "tmsid=$tmsid, [html_link /object/$objectid ShowingObject]$strSeries"
    if { $rec != "" } {
      append strMFSData ", "
      append strMFSData [html_link /object/$recfsid RecordingObject]
    }
 
    puts $chan [tr "" [td "MFS Data"] [td $strMFSData]]

    puts -nonewline $chan [html_table_end]
  }

  set actionstr ""
  set nowtime [clock seconds]
  if { $rec != "" } {
    if { $state == 6 } {
      append actionstr [tr "" [td [html_link "/confirm/can/$recfsid" "Cancel Recording"]]]
    } elseif { $state == 3 } {
      append actionstr [tr "" [td [html_link "/stoprecording/$recfsid" "Stop Recording"]]]
    } elseif { $state == 4 } {
      append actionstr [tr "" [td [html_link "/editprogram/$recfsid" "Edit Program"]]]
      append actionstr [tr "" [td [html_link "/confirm/del/$recfsid" "Delete Recording"]]]
    } elseif { $state == 2 } {
      if { $nowtime < $showingstart } {
        append actionstr [tr "" [td [html_link "/recoptions/$objectid" "Record"]]]
      } elseif { $nowtime < ($showingstart + $durationsecs) } {
        append actionstr [tr "" [td [html_link "/recoptions/$objectid" "Record Partial"]]]
      }
    } elseif { $state == 5 } {
      if { $parts != "" } {
        append actionstr [tr "" [td [html_link "/confirm/un/$recfsid" "Undelete"]]]
      }
    }
  } else {
    if { $nowtime < $showingstart } {
      append actionstr [tr "" [td [html_link "/recoptions/$objectid" "Record"]]]
    } elseif { $nowtime < ($showingstart + $durationsecs) } {
      append actionstr [tr "" [td [html_link "/recoptions/$objectid" "Record Partial"]]]
    }
  }
  if { $rec != "" && $programsourcefsid != "" && ($programsourcetype == 1 || $programsourcetype == 2) } {
    append actionstr [tr "" [td [html_link "/editseasonpass/$programsourcefsid" "Edit Season Pass"]]]
  } else {
    set sp_index [lsearch $cache_sp_key "$seriesfsid|$stationid"]
    if { $sp_index != -1 } {
      append actionstr [tr "" [td [html_link "/editseasonpass/[lindex $cache_sp_fsid $sp_index]" "Edit Season Pass"]]]
    } elseif { $episodic == 1 } {
      if $::needsNpkChannel {
        append actionstr [tr "" [td [html_link "/getseasonpass/$objectid" "Get Season Pass <i>(experimental)</i>"]]]
      } else {
        append actionstr [tr "" [td [html_link "/getseasonpass/$objectid" "Get Season Pass"]]]
      }
    }
  }
  if { $actionstr != "" } {
    puts $chan [table "Actions"]
    puts $chan $actionstr
    puts $chan [html_table_end]
  }
  # add embedded player if selected and show is available
#  if {$rec != "" && ($state == 3 || $state == 4) && $::conf(embed_player)} { 
#    WritePlayStreamToJS $chan 
#  }
